package algo.heuristic;

import algo.datastructure.Graph;
import algo.test.Clustering;
import algo.util.Util;

public class Heuristic {

    private final static int rounds = 10;

    public static int computeUpperBound(Graph g, int t) {
        return computeUpperBoundWithBlockPartition(g, t).getCost();
    }

    public static BlockPartitionResult computeUpperBoundWithBlockPartition(Graph g, int t) {
        boolean previousPrintState = Util.printLogs;
        Util.printLogs = false;

        BlockPartitionResult bestBlockPartition = null;

        for (int i = 0; i < rounds; i++) {
            BlockPartitionResult res = MergeHeuristic.solve(g, t);
            if (bestBlockPartition ==  null || res.getCost() < bestBlockPartition.getCost()) bestBlockPartition = res;
        }
        for (int i = 0; i < rounds; i++) {
            BlockPartitionResult res = SplitHeuristic.solve(g, t);
            if (bestBlockPartition ==  null || res.getCost() < bestBlockPartition.getCost()) bestBlockPartition = res;
        }

        Util.printLogs = previousPrintState;
        Clustering.savClustering(bestBlockPartition);
        return bestBlockPartition;
    }
}
