import numpy as np


def create_permutations(size):
    permutation = np.full(size, 0)
    remaining = set(np.arange(0, size))
    with open(f"permutations_{size}.txt", "w") as file:
        create_permutations_aux(permutation, remaining, 0, file)


def create_permutations_aux(permutation, remaining, index, file):
    if index == len(permutation):
        res = list(map(lambda x: str(x), permutation))
        file.write(f"{' '.join(res)}\n")
        return
    remaining_list = list(remaining)
    for val in remaining_list:
        permutation[index] = val
        remaining.remove(val)
        create_permutations_aux(permutation, remaining, index + 1, file)
        remaining.add(val)


if __name__ == '__main__':
    for i in range(6, 8):
        create_permutations(i)
