package algo.util;

import algo.datastructure.Graph;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.nio.file.Path;
import java.util.HashMap;
import java.util.Map;

public class IO {

    public static Graph parseGraph() throws IOException {
        return parseGraph(null);
    }

    public static Graph parseGraph(Path path) throws IOException {
        InitialGraph graph = new InitialGraph();
        Map<String, InitialVertex> nodeMappings = new HashMap<>();

        BufferedReader bi = new BufferedReader(
                (path == null) ? new InputStreamReader(System.in) : new FileReader(path.toFile()));

        String line;
        int idCounter = 0;
        while ((line = bi.readLine()) != null) {
            if (line.startsWith("#") || line.startsWith("%")) continue;
            String[] split = line.split("\\s");
            String nodeA = split[0];
            InitialVertex a, b;
            a = nodeMappings.get(nodeA);
            if (a == null) {
                a = new InitialVertex(idCounter++, nodeA);
                nodeMappings.put(nodeA, a);
                graph.addNode(a);
            }

            if (split.length != 1) {//there is an edge, otherwise "a" is isolated
                String nodeB = split[1];
                b = nodeMappings.get(nodeB);
                if (b == null) {
                    b = new InitialVertex(idCounter++, nodeB);
                    nodeMappings.put(nodeB, b);
                    graph.addNode(b);
                }
                graph.addEdge(a, b);
            }
        }
        return new Graph(graph);
    }
}
